<?php
class spx_gallery {
	
	public static function get_file_info($s){
		$a = pathinfo($s);
		return $a;
	}
	public static function get_file_extension($s){
		$a = pathinfo($s);
		return $a['extension'];
	}

	// List all 'jpg' files in a directory, recursively
	public static function get_images($folder) {
		$files = array();
		if(!is_dir($folder)) return false;
		if ($handle = opendir($folder)) {
			while (false !== ($file = readdir($handle))) {
				if ($file != '.' && $file != '..' && !preg_match('/^(.*\.)tb.([^.]+)$/D', $file)) {
					$ext = @strtolower(self::get_file_extension($file));
					if($ext == 'jpg' || $ext == 'png' || $ext == 'gif') {
						$tmp = array();
						if (file_exists("$folder/$file")) {
							$ainfo = self::get_file_info($file);
							$tmp["info"]=$ainfo;
							$tmp["exist"]= "Le fichier $file existe.";
							$lastModified = date('F d Y, H:i:s',filemtime("$folder/$file"));
							$isodate = date('yyyy-mm-dd',filemtime("$folder/$file"));
							list($width, $height) = getimagesize("$folder/$file"); 
							// >1 --> paysage =1 carré < 1 --> portrait 
							$ratio = $width/ $height;
							$tmp["width"]=$width;
							$tmp["height"]=$height;
							$tmp["ratio"]=$ratio;
							$surface=$width*$height;
							
							$tmp["placement"]=false;
							// 100 X 100 300X300 800X600
							if ($surface<=10000){
								$tmp["surface"]="small";
							}else if ($surface<=90000){
								$tmp["surface"]="middle";
							}else{
								$tmp["surface"]="bigger";
							} 
							//                paysage portrait
							// 768 / 1336  --> 1,7786 0.562
							// 800 / 600 ---> 1,333 0.75
							// 600 / 132 panoramique 4.54
							if ($ratio>=4){
								$tmp["mode"]="landscape++";
							}else if ($ratio>=1.77){
								$tmp["mode"]="landscape+";
							}else if ($ratio>=1.33){
								$tmp["mode"]="landscape";
							}else if ($ratio<=0.22){
								$tmp["mode"]="portrait++";
							}else if ($ratio<=0.57){
								$tmp["mode"]="portrait+";
							}else if ($ratio<=0.75){
								$tmp["mode"]="portrait";
							}else{
								$tmp["mode"]="square";
							} 
							
							if($lastModified == NULL) $lastModified = filemtime(utf8_decode("$folder/$file"));
						
						}else{
							 $tmp["exist"]= "Le fichier $file n'existe pas.";
							
						}
						$tmp["file"]="$folder/$file";
						$tmp["date"]=$lastModified;
						$tmp["isodate"]=$isodate;
					
						$files[] = $tmp;
					}
					if(is_dir("$folder/$file")) {
						$recursive = self::get_images("$folder/$file");
						foreach($recursive as $rfile) $files[] = $rfile;
					}
				}
			}
			closedir($handle);
		}
		return $files;
	}

}
?>
