/*
 # -- BEGIN LICENSE BLOCK ----------------------------------
 #
 # This file is part of tinyMCE.
 # YouTube for tinyMCE
 # Copyright (C) 2011 - 2013  Gerits Aurelien <aurelien[at]magix-dev[dot]be> - <contact[at]aurelien-gerits[dot]be>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.

 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 # -- END LICENSE BLOCK -----------------------------------
 */
// Namespace Youtube
var simplegallery = (function($, window, document, undefined){
    

    

    /**
     * Format HTML
     * @param mode
     * @param size
     * @param data
     * @returns {string|string}
     */
    function dataToHtml(){
        // get data from formular
		
		var style = $('#oscitas-button-style').val();
		return '<button type="button" class="'+style+'">Default</button>';
    }

   

    function create(pluginObj){
		console.log("create");
		
	}
	
	
	
	 /**
     * Insert content when the window form is submitted
     * @returns {string}
     */
    function insert(){
	
			var $spx_prefix="SPXWSIMPLEGALLERY";
			// defines the options and their default values
			// again, this is not the most elegant way to do this
			// but well, this gets the job done nonetheless
			// [SPXWSIMPLEGALLERY id=001 type="masonry" col="col-lg-2 col-md-4 col-sm-6 col-xs-12" imgsize="100" imgpadding="30" pos="" width="100%" displaytitle="truee" colortheme="dark"]
			var shortcode = '['+$spx_prefix;
			// id
			shortcode += ' id="'+$('#id_simplegallery-id').val()+'"';
			// type
			shortcode += ' type="'+$('#id_type').val()+'" ';
			// col d_gridlg
			shortcode += ' col="'+$('#id_gridlg').val()+' '+$('#id_gridmd').val()+' '+$('#id_gridsm').val()+' '+$('#id_gridxs').val()+'" ' ;
			// imgsize
			shortcode += ' imgsize="'+$('#id_imgsize').val()+'" ';
			// imgpadding
			shortcode += ' imgpadding="'+$('#id_imgpadding').val()+'" ';
			// pos
			shortcode += ' pos="'+$('#id_pos').val()+'" ';
			// width
			shortcode += ' width="'+$('#id_width').val()+'" ';
			// displaytitle
			shortcode += ' displaytitle="'+$('#id_displaytitle').val()+'" ';
			// colortheme
			shortcode += ' colortheme="'+$('#id_colortheme').val()+'" ';
			// clearfix
			shortcode += ' clearfix="'+$('#id_clearfix').val()+'" ';
			
			shortcode += ']';
	
			return shortcode;
	
	}
	
	
	
	

    /**
     * public
     */
    return {
        preview:function(){
            //console.log(convertUrl($('#youtubeID').val()));
            $('#preview').html(
                dataToHtml()
            );
        },
        run:function(){
            if(insert()){
                //editor.insertContent(objectCode);
                parent.tinymce.activeEditor.insertContent(insert());
                parent.tinymce.activeEditor.windowManager.close();
            }else{
                parent.tinymce.activeEditor.windowManager.close();
            }
        },
        runPreview:function(){
            create();
        }
    }
})(jQuery, window, document);
/**
 * Execute namespace youtube
 */
 
var translate = parent.tinymce.util.I18n.translate;

 
$(function(){
    // Init templatewith mustach  "pluginStyle": parent.tinymce.util.I18n.translate('pluginStyle'),
	
	
    var data = {
        "pluginStyle": translate('pluginStyle'),
		"simplegalleryType": translate('simplegalleryType'),
		"simplegalleryId": translate('simplegalleryId'),
		"simplegalleryGridLG": translate('simplegalleryGridLG'),
		"simplegalleryGridMD": translate('simplegalleryGridMD'), 
		"simplegalleryGridSM": translate('simplegalleryGridSM'), 
		"simplegalleryGridXS": translate('simplegalleryGridXS'),
		"simplegalleryImgsize": translate('simplegalleryImgsize'), 
		"simplegalleryImgpadding" : translate('simplegalleryImgpadding'), 
		
		"simplegalleryPos" : translate('simplegalleryPos'), 
		"simplegalleryWidth" : translate('simplegalleryWidth'), 
		"simplegalleryDisplaytitle" : translate('simplegalleryDisplaytitle'), 
		"simplegalleryColortheme" : translate('simplegalleryColortheme'), 
		"simplegalleryClearfix" : translate('simplegalleryClearfix'), 
		
		
		"simplegallerys": osimplegallerys
		

    };
    //Use jQuery's get method to retrieve the contents of our template file, then render the template.
    $.get('../simplegallery/view/forms.html' , function (template) {
        filled = Mustache.render( template, data );
        $('#template-container').append(filled);
		
		// bootstrap nav
		$(document).ready(function(){
			$('.nav-tabs a').click(function (e) {
				console.log ("test !!!!");
				e.preventDefault();
				$(this).tab('show');
			})
		});
		
		
        // preview
        simplegallery.runPreview();
        $('#insert-btn').on('click',function(){
            simplegallery.run();
        });
    });
});