<?php
/**
 * Plugin spxwsimplegallery
 *
 * @package SPX
 * @version	
 * @date	07/07/2014
 * @author	JE-EVRARD
 **/
class spxwsimplegallery extends plxPlugin {
	
	
	/**
	 * Constructeur de la classe spxwsimplegallery
	 *
	 * @param	default_lang	langue par dfaut utilise par PluXml
	 * @return	null
	 * @author	
	 **/
	public function __construct($default_lang) {
		
		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		
		# droits pour accder  la page config.php du plugin
		$this->spxname="spxwsimplegallery";
		$this->initconfiguration();
		$this->setConfigProfil(PROFIL_ADMIN);
		

		# Dclarations des hooks
		if(!defined('PLX_ADMIN')) {
			$this->addHook('ThemeEndHead', 'addLibrairy');
			//$this->addHook('ThemeEndHead', 'addCssLibrairy');
			//$this->addHook('ThemeEndBody', 'addJSlibrairy');
		}
		
		$this->addHook('spxwsimplegallery::getSimplegalleryID', 'getSimplegalleryID');
		$this->addHook('spxwsimplegallery::getSimplegalleryTitle', 'getSimplegalleryTitle');
	}

	public function initconfiguration() {
		# VARIOUS PARAMS
		$this->setParam('spxdatas_widget', '1', 'string');
		$this->setParam('spxshortcodes_shortcode', '1', 'string');
		
		// add the button in tiny
		$this->setParam('spxtynimce_plugin', '1', 'string');
		$sname = "simplegallery";
		$s = "../../".$this->spxname."/spxtynimce/simplegallery/plugin.js";
		$splug = $sname.'" : "'.$s;
		$this->setParam('spxtynimce_externalplugin', '"'.$splug.'"', 'string');
		$this->setParam('spxtynimce_toolbar', $sname, 'string');
		
		//if (plxUtils::strCheck($this->getParam('polaroidback'))=="") $this->setParam('polaroidback', '1', 'string');
		//if (plxUtils::strCheck($this->getParam('dataformat'))=="") $this->setParam('dataformat', 'xml', 'string');
		
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmin'.$key))=="") $this->setParam('profiladmin'.$key,$this->get_adminright_list(),'string');
			
		}
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmincontent'.$key))=="") $this->setParam('profiladmincontent'.$key,$this->get_adminrightcontent_list(),'string');
		}
		
	}
	/**
	 * Mthode qui ajoute le fichier css 
	 *
	 * @return	stdio
	 * @author	Evrard jerome
	 **/
	
	public function addLibrairy() {
		$this->addCssLibrairy();
		$this->addJSlibrairy();
	}
	/**
	 * Mthode qui ajoute le fichier css 
	 *
	 * @return	stdio
	 * @author	Evrard jerome
	 **/
	
	public function addCssLibrairy() {
		echo "\n".'
		<link rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxwsimplegallery/css/site.css" />
		';
		
		
	}
	/**
	 * Mthode qui ajoute les lib et init
	 *
	 * @return	
	 * @author	Evrard jerome
	 **/
	public function addJSlibrairy() {
		echo "\n".'
		
		<script type="text/javascript">
		/* <![CDATA[ */
		!window.jQuery && document.write(\'<script  type="text/javascript" src="//cdnjs.cloudflare.com/ajax/libs/jquery/2.1.3/jquery.min.js"><\/script>\');
		/* !]]> */
		</script>
		
		<script src="http://desandro.github.io/imagesloaded/imagesloaded.pkgd.js"></script>
		
		<script src="https://cdnjs.cloudflare.com/ajax/libs/masonry/3.3.2/masonry.pkgd.min.js"></script>
		
		<script>
				// http://codepen.io/desandro/pen/bIFyl
				( function( window ) {

					\'use strict\';

					var $progress, $status;
					var supportsProgress;
					var loadedImageCount, imageCount;

					$( function() {
						var $container = $(\'.spxwsimplegallery-container\');
						imageCount = $container.find("img").length;
						loadedImageCount=0;
						console.log("imageCount = "+imageCount);
						
						console.dir($container);
						// progress( onProgress );
						
						 // use ImagesLoaded
						$container.imagesLoaded()
						  .progress( onProgress );
						/*
						$container.imagesLoaded( function() {
							console.log ("all images are loaded");
							// fix issue for loading image
							$(".spxwsimplegallery-container .spxwsimplegallery-gallery").masonry();
						}); 
						*/
						
						// triggered after each item is loaded
						function onProgress( imgLoad, image ) {
							// change class if the image is loaded or broken
							var $item = $( image.img ).parent().parent();
							$item.removeClass(\'is-loading\');
							if ( !image.isLoaded ) {
								$item.addClass(\'is-broken\');
							}
							loadedImageCount++;
							console.log("loadedImageCount="+loadedImageCount);
							if (loadedImageCount==imageCount){
								console.log("all image loaded");
								$(".spxwsimplegallery-container  .spxwsimplegallery-gallery").masonry();
							}
					
						}
					});
				
				})( window );

		
		</script>
		
		
		';
		
	}
	
	
	/**
	 * Mthode qui retourne les profils utilisateurs
	 *
	 * @return	// foreach($aProfils as $key=>$val) {
	 * @author	
	 **/
	
	public function get_aprofil() {
		# Tableau des profils
		return array(
			PROFIL_ADMIN => L_PROFIL_ADMIN,
			PROFIL_MANAGER => L_PROFIL_MANAGER,
			PROFIL_MODERATOR => L_PROFIL_MODERATOR,
			PROFIL_EDITOR => L_PROFIL_EDITOR,
			PROFIL_WRITER => L_PROFIL_WRITER
		);
		
	}
	
	# define admin right list for sliders list
	public function get_adminright_list() {
		return "view create modify delete";
	}
	
	# define admin right list for slider content
	public function get_adminrightcontent_list() {
		return "create modify delete";
	}
	
	public function get_tableuserlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			foreach($aright as $key2=>$val2) {
				if ($val2=="view"){
					$s.=$key.',';
					break;	
				}
			}
		}
		return substr ($s, 0, -1);
	}
	
	public function get_rightCMDlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			$create='0';
			$modify='0';
			$delete='0';
			foreach($aright as $key2=>$val2) {
				if ($val2=="create"){
					$create='1';
				}
				if ($val2=="modify"){
					$modify='1';
				}
				if ($val2=="delete"){
					$delete='1';
				}
			}
			$s.=$key.':'.$create.$modify.$delete.',';
		}
		return substr ($s, 0, -1);
		//return '3:010,4:010';
	}
	
	public function write_table() {
		$xml =$this->get_table_spxdatas();
		$path = PLX_PLUGINS.'spxwsimplegallery/spxdatas/table/table.php';
		$bwrite = plxUtils::write($xml,$path);
		/*
		if($bwrite) {
			return plxMsg::Info(L_SAVE_SUCCESSFUL);		
		} else {
			return plxMsg::Error(L_SAVE_ERR);
		}
		*/
	}
	
	
	
	# define admin right list
	public function get_table_spxdatas() {
		$dataformat='';
		if ($this->getParam('dataformat') =="json")
			$dataformat='dataformat="json"';
		$s='';
		$s.='<table name="spxwsimplegallerys" maxparam="2" groupe="spxwsimplegallery" '.$dataformat.' tableuserlevel="'.$this->get_tableuserlevel().'" rightCMDlevel="'.$this->get_rightCMDlevel().'" >';
		$s.='<description><![CDATA[<p>List of gallery</p>]]></description>';
			$s.='<column>';
					$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
					$s.='<parameter  name="gallery_content" type="cdata" option="subtable/spxwsimplegallery" ></parameter>';
			$s.='</column>';
		$s.='</table>';
		
		
		$s.='<table name="spxwsimplegallery" maxparam="3" groupe="spxwsimplegallery" type="subtable" order="true" '.$dataformat.' rightCMDlevel="'.$this->get_rightCMDlevel('profiladmincontent').'" >';
		$s.='<description><![CDATA[<p>Your gallery</p>]]></description>';
			$s.='<column>';
				
				$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
				$s.='<parameter  name="image" type="cdata" option="image" ></parameter>';
				
				
				
			$s.='</column>';
		$s.='</table>';
		return $s;
	}
	
	# getloc call by spxdatas
	public function get_loc($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
	}
	
	# getdefaultloc use by config traduction
	public function get_loc_default($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin_default.php';
		
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
		
	}
	
	# record loc for spxdatas
	public function set_loc($mylang) {
		$atraddefault = $this->get_loc_default($mylang);
		$LANG="LANG";
		$out="<?php
		
					$$LANG = array(";
		foreach($atraddefault as $key=>$val) {
			
			$code = 'admin_loc_'.$trad.'_'.$key;
			$check = $this->getParam($code);
			if ($check=="-") {
				$loc="";
			}else if ($check=="") {
				$loc=$val;
			}else{
				$loc=$check;
			}
			$loc = str_replace("'", "\'", $loc);
			
			$out.="'".$key."'			=> '".$loc."',";
		}
		$out.="	
					);
					?>";
		$fileloc = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		plxUtils::write($out,$fileloc);
	}
	
	
	# get html content for slider
	public function getSimplegalleryID($atts) {
		$filter = 'spxwsimplegallerys_id='.$atts["id"];
		$s='';
		$s.= $this->get_gallery_request($filter,$atts);	
		return $s;
	}
	
	# get html content for slider
	public function getSimplegalleryTitle($atts) {
		$filter = 'title='.$atts["title"];
		$s.= $this->get_gallery_request($filter,$atts);		
		return $s;
	}
	
	public function get_gallery_request($filter,$atts) {

		$plxMotor = plxMotor::getInstance();
		$IMAGEPATH = isset($plxMotor->aConf['medias']) ? plxUtils::getRacine().$plxMotor->aConf['medias'] : plxUtils::getRacine().$plxMotor->aConf['images'];	
		$IMAGEPATH2 = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];			
		
		$o= array();
		$o["table"]="spxwsimplegallerys";
		$o["filter"]=$filter;
		$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
		
		$o["out"]="array";
		$tmp2 = $tmp->getData($o);
		
		/*echo ("<pre>");
		print_r($tmp2);
		echo ("</pre>");*/
		$imgpadding = $atts["imgpadding"];
		$pos = $atts["pos"];
		$style = "";
		switch ($pos) {
			case "left":
				$posstyle="float: left;";
				$style_gallery = 'margin-top:-'.$imgpadding.'px; margin-left:-'.$imgpadding.'px;';
				break;
			case "right":
				$posstyle="float: right;";
				$style_gallery = '';
				break;
			case "center":
				$posstyle="display: block; margin-left: auto; margin-right: auto;";
				$style_gallery = '';
				break;
			
		}
		$atts ["style_container"]= 'width:'.$atts["width"].';';
		$atts ["style_container"].= $posstyle;
		
		
		$atts ["style_gallery"]= $style_gallery;
		//return $this->get_square_gallery($IMAGEPATH, $IMAGEPATH2, $tmp2, $filter,$atts);
		
		return $this->get_template_gallery($IMAGEPATH, $IMAGEPATH2, $tmp2, $filter,$atts);
		return $this->get_square_response_gallery($IMAGEPATH, $IMAGEPATH2, $tmp2, $filter,$atts);
	}
	
	public function get_square_response_gallery($IMAGEPATH, $IMAGEPATH2, $tmp, $filter,$atts) {
		$s='';
	
		$imgpadding = $atts["imgpadding"];
		$style_container = $atts["style_container"];
		$style_gallery = $atts["style_gallery"];
		$colortheme = "spxwsimplegallery-container-".$atts["colortheme"];
		$col=$atts["col"];
		$imgsize = $atts["imgsize"];
		
		if ($atts["type"]=="masonry"){
			$IMAGERESIZE = PLX_PLUGINS.$this->spxname."/imageResize2.php?w=".$imgsize."&transform=reduce&color=0";
		}else{
			$IMAGERESIZE = PLX_PLUGINS.$this->spxname."/imageResize2.php?w=".$imgsize."&h=".$imgsize."&transform=reducecrop&color=0";
		}
		
		$s.='<div id="spxwsimplegallery-'.$tmp[0]["spxwsimplegallerys_id"].'" class="spxwsimplegallery-container '.$colortheme.'" style="'.$style_container.'">';
			$s.='<div class="spxwsimplegallery-gallery" >';
			if (count($tmp)==0) return $s;
			foreach($tmp[0]["gallery_content"] as $key=>$val) {
				
				if ($col!=""){
					$s.='<div class="spxwsimplegallery-item is-loading '.$col.'" style="padding:'.($imgpadding/2).'px; ">';
				}else{
					$s.='<div class="spxwsimplegallery-item" style="margin-top:'.$imgpadding.'px; margin-left:'.$imgpadding.'px; width:'.$imgsize.'px;" >';
					
				}
				
					$img = $IMAGEPATH2.$val["image"];
					$imgsrc = $IMAGERESIZE."&file=../../".$img; 
					
					$s.='
					
					<a title="'.$val["title"].'" data-spxlighbox="true" href="'.$IMAGEPATH.$val["image"].'" class="spxwsimplegallery-img zgallery'.$tmp[0]["spxwsimplegallerys_id"].'" >
					<img onload="$(this).data(\'loaded\', \'loaded\');" width="100%" height="auto" src="'.$imgsrc.'" alt=""/>
					
					</a>';
					
					if ($atts ["displaytitle"]=='true'){
						if ($val["title"] !="")
							$s.='<div class="spxwsimplegallery-itemtitle" >'.$val["title"].'</div>';
					}
					
				$s.='</div>';
			}
			
			
			$s.='</div>';
		$s.='</div>';
		
		
		
		return $s;
	}
	
	public function get_template_gallery($IMAGEPATH, $IMAGEPATH2, $tmp, $filter,$atts) {
		$imgpadding = $atts["imgpadding"];
		$style_container = $atts["style_container"];
		$style_gallery = $atts["style_gallery"];
		$colortheme = "spxwsimplegallery-container-".$atts["colortheme"];
		$col=$atts["col"];
		$imgsize = $atts["imgsize"];
		$formatcontainer = $atts["formatcontainer"];
		$formatitem = $atts["formatitem"];
		$clearfix = $atts ["clearfix"];
		
		if ($atts["type"]=="masonry"){
			$IMAGERESIZE = PLX_PLUGINS.$this->spxname."/imageResize2.php?w=".$imgsize."&transform=reduce&color=0";
		}else{
			$IMAGERESIZE = PLX_PLUGINS.$this->spxname."/imageResize2.php?w=".$imgsize."&h=".$imgsize."&transform=reducecrop&color=0";
		}
		
		$s='';
		
		# container
		/*
		<div #container_data_set style="#container_style" class="#container_class" >
			<div #subcontainer_data_set class="#subcontainer_class" >
				#items
			</div>
		</div>
		*/
		$s = str_replace('#container_data_set','id="spxwsimplegallery-'.$tmp[0]["spxwsimplegallerys_id"].'"' ,$formatcontainer);
		$s = str_replace('#container_style',$style_container ,$s);
		$s = str_replace('#container_class','spxwsimplegallery-container '.$colortheme ,$s);
		# subcontainer
		$s = str_replace('#subcontainer_data_set', '' ,$s);
		$s = str_replace('#subcontainer_class','spxwsimplegallery-gallery' ,$s);
		
		
		//$s.='<div id="spxwsimplegallery-'.$tmp[0]["spxwsimplegallerys_id"].'" class="spxwsimplegallery-container '.$colortheme.'" style="'.$style_container.'">';
			//$s.='<div class="spxwsimplegallery-gallery" >';
		
		
		$sitems = '';
		
				if (count($tmp)==0) return $s;
				foreach($tmp[0]["gallery_content"] as $key=>$val) {
					# items
					/*
					<div style="#container_style" class="#container_class" >
										
						<a #itemlink_data_set title="#itemlink_title" href="#itemlink_url" class="#itemlink_class" >
							<img #itemimg_data_set width="#itemimg_width" height="#itemimg_height" src="#itemimg_src" alt="#itemimg_alt">
						</a>

						<div #itemtitle_data_set class="#itemtitle_class" >#itemtitle_title</div>

					</div>
					*/
					
					$s2='';
					if ($col!=""){
						//$s.='<div class="spxwsimplegallery-item is-loading '.$col.'" style="padding:'.($imgpadding/2).'px; ">';
						$s2 = str_replace('#itemcontainer_class','spxwsimplegallery-item is-loading '.$col,$formatitem);
						$s2 = str_replace('#itemcontainer_style','padding:'.($imgpadding/2).'px;' ,$s2);
					}else{
						//$s.='<div class="spxwsimplegallery-item" style="margin-top:'.$imgpadding.'px; margin-left:'.$imgpadding.'px; width:'.$imgsize.'px;" >';
						$s2 = str_replace('#itemcontainer_class','spxwsimplegallery-item',$formatitem);
						$s2 = str_replace('#itemcontainer_style','margin-top:'.$imgpadding.'px; margin-left:'.$imgpadding.'px; width:'.$imgsize.'px;' ,$s2);
						
					}
					
					$img = $IMAGEPATH2.$val["image"];
					$imgsrc = $IMAGERESIZE."&file=../../".$img;
					
					# a
					$s2 = str_replace('#itemlink_data_set','data-spxlighbox="true"' ,$s2);
					$s2 = str_replace('#itemlink_title',$val["title"],$s2);
					$s2 = str_replace('#itemlink_url',$IMAGEPATH.$val["image"] ,$s2);
					$s2 = str_replace('#itemlink_class','spxwsimplegallery-img zgallery'.$tmp[0]["spxwsimplegallerys_id"] ,$s2);
					# img
					$s2 = str_replace('#itemimg_data_set','onload="$(this).data(\'loaded\', \'loaded\');"' ,$s2);
					$s2 = str_replace('#itemimg_width','100%' ,$s2);
					$s2 = str_replace('#itemimg_height','auto' ,$s2);
					$s2 = str_replace('#itemimg_src',$imgsrc ,$s2);
					$s2 = str_replace('#itemimg_alt','' ,$s2);
					# title
					if ($atts ["displaytitle"]=='true'){
						$display_none = '';
					}else{
						$display_none = 'style="display: none;"';
					}
					
					$s2 = str_replace('#itemtitle_data_set',$display_none ,$s2);
					$s2 = str_replace('#itemtitle_class','spxwsimplegallery-itemtitle' ,$s2);
					$s2 = str_replace('#itemtitle_title',$val["title"] ,$s2);
					
					//$s.=$s2;
					$sitems .= $s2;
				}
		
		
		
			//$s.='</div>';
		//$s.='</div>';
		
		//echo ("format item = ".$format);
		
		$s = str_replace('#items',$sitems ,$s);
		//return $s;
		
		if ($clearfix=='true') $s.='<div class="spxwsimplegallery-clearfix"></div>';
		
		return $s;
		
	}
	
	/*
	public function get_square_gallery($IMAGEPATH, $IMAGEPATH2, $tmp, $filter,$atts) {
		$imgsize = $atts["imgsize"];
		$imgpadding = $atts["imgpadding"];
		$style_container = $atts["style_container"];
		$style_gallery = $atts["style_gallery"];
		$colortheme = "spxwsimplegallery-container-".$atts["colortheme"];
		
		
		if ($atts["type"]=="masonry"){
			$IMAGERESIZE = PLX_PLUGINS.$this->spxname."/imageResize2.php?w=".$imgsize."&transform=reduce&color=0";
		}else{
			$IMAGERESIZE = PLX_PLUGINS.$this->spxname."/imageResize2.php?w=".$imgsize."&h=".$imgsize."&transform=reducecrop&color=0";
		}
		
		$s='';
		$s.='<div id="spxwsimplegallery-'.$tmp[0]["spxwsimplegallerys_id"].'" class="spxwsimplegallery-container '.$colortheme.'" style="'.$style_container.'">';
		$s.='<div style="'.$style_gallery.'" class="spxwsimplegallery-gallery squares js-masonryyyy"
  data-masonry-options=\'{ "itemSelector": ".spxwsimplegallery-item", "columWidth": '.($imgsize+$imgpadding).' }\' >';
			if (count($tmp)==0) return $s;
			foreach($tmp[0]["gallery_content"] as $key=>$val) {
				$s.='<div class="spxwsimplegallery-item" style="margin-top:'.$imgpadding.'px; margin-left:'.$imgpadding.'px; width:'.$imgsize.'px;" >';
					$img = $IMAGEPATH2.$val["image"];
					$imgsrc = $IMAGERESIZE."&file=../../".$img; 
					
					
					
					$s.='
					
					<a title="'.$val["title"].'" data-spxlighbox="true" href="'.$IMAGEPATH.$val["image"].'" class="spxwsimplegallery-img zgallery'.$tmp[0]["spxwsimplegallerys_id"].'" >
					<img width="100%" height="auto" src="'.$imgsrc.'" alt=""/>
					
					</a>';
					
					if ($atts ["displaytitle"]=='true'){
						if ($val["title"] !="")
							$s.='<div class="spxwsimplegallery-itemtitle" >'.$val["title"].'</div>';
					}
					
				$s.='</div>';
			}
		
			$s.='</div>';
		$s.='</div>';
		
		return $s;
	}
	*/
	
	
	
	
	
	
	
	


}

?>